const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const stock_movements = sequelize.define(
    'stock_movements',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

movement_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"entree",


"sortie",


"ajustement"

        ],

      },

quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

movement_time: {
        type: DataTypes.DATE,
      
      

      },

reason: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  stock_movements.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity





























//end loop



    db.stock_movements.belongsTo(db.stock_items, {
      as: 'stock_item',
      foreignKey: {
        name: 'stock_itemId',
      },
      constraints: false,
    });

    db.stock_movements.belongsTo(db.restaurants, {
      as: 'restaurant',
      foreignKey: {
        name: 'restaurantId',
      },
      constraints: false,
    });

    db.stock_movements.belongsTo(db.users, {
      as: 'performed_by_user',
      foreignKey: {
        name: 'performed_by_userId',
      },
      constraints: false,
    });




    db.stock_movements.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.stock_movements.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return stock_movements;
};


